
# line 2 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
/*
 * The Termprocessor Kimwitu
 *
 * Copyright (c) 1991 University of Twente, Dept TIOS.
 * All rights reserved.
 *
 */

# line 11 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
/*
 * kimwy.y
 */
#if ! (defined(lint) || defined(SABER) || defined(CODECENTER))
static char kimwy_yAccesSid[] = "@(#)$Id: kimwy.y,v 2.29 1995/07/11 18:38:52 belinfan Rel $";
#endif

# line 20 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
/***************************************************************************/
/*
 * Name conventions: tokens are in CAPITALS
 * nonterminals are in lowercase
 * operators are capitalized
 *
 */

# line 29 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
#include "k.h"
#include "parse.h"
#include "extocc.h"
#include "defocc.h"
#include "util.h" /* for the v_add_to routines */


static ID pl_phylum;						/* local kimwy.y var */
static ID pl_withvariable;					/* local kimwy.y var */
static filelinestack pl_filelinestack;				/* local kimwy.y var */
static nooperatorsstack pl_nooperatorsstack;			/* local kimwy.y var */
static int non_default_outmostpattern = 0;			/* local kimwy.y var */

#define dollar_mark_set() (pl_withvariable != 0)
#define do_MainC() do { if ( dollar_mark_set() ) do_NORMAL(); else do_C(); } while(kc_zero_constant)
extern void do_NORMAL();
extern void do_CEXPR();
extern void do_CEXPRDQ();
extern void do_CEXPRSQ();
extern void do_C();
extern void yyerror();


#define pf_setfileline(x) do { (x)->file = pg_filename; \
			       (x)->line = pg_lineno; \
			     } while(kc_zero_constant)
#define pf_pushfileline() pl_filelinestack = Consfilelinestack( FileLine( pg_filename, pg_lineno ), pl_filelinestack )
#define pf_setstacktopfileline(x) do { (x)->file = pl_filelinestack->u.Consfilelinestack.fileline_1->u.FileLine.casestring_1; \
				       (x)->line = pl_filelinestack->u.Consfilelinestack.fileline_1->u.FileLine.int_1; \
				     } while(kc_zero_constant)
#define pf_topfileline() (pl_filelinestack->u.Consfilelinestack.fileline_1)
#define pf_popfileline() do { filelinestack tmp_pl_filelinestack = pl_filelinestack; \
		              pl_filelinestack = pl_filelinestack->u.Consfilelinestack.filelinestack_1; \
		              free_fileline( tmp_pl_filelinestack->u.Consfilelinestack.fileline_1, True ); \
			      free_filelinestack( tmp_pl_filelinestack, False ); \
			    } while(kc_zero_constant)
#define pf_setwithvariable(x) pl_withvariable = (x)
#define pf_resetwithvariable() pl_withvariable = 0
#define pf_push_no_operators() pl_nooperatorsstack = Consnooperatorsstack( non_default_outmostpattern, pl_nooperatorsstack );
#define pf_pop_no_operators() do { nooperatorsstack tmp_pl_nooperatorsstack = pl_nooperatorsstack; \
				   non_default_outmostpattern = pl_nooperatorsstack->u.Consnooperatorsstack.int_1; \
		                   pl_nooperatorsstack = pl_nooperatorsstack->u.Consnooperatorsstack.nooperatorsstack_1; \
			           free_nooperatorsstack( tmp_pl_nooperatorsstack, False ); \
			         } while(kc_zero_constant)

# define ID 257
# define INT 258
# define CNEWLINES 259
# define CLINE 260
# define CEXPRESSION 261
# define DOLLARVAR 262
# define INCLUDE 263
# define INCLUDESTART 264
# define INCLUDEEND 265
# define LIST 266
# define ARROW 267
# define STATIC 268
# define WITH 269
# define FOREACH 270
# define DEFAULT 271
# define UNPBLOCKSTART 272
# define UNPBLOCKEND 273
# define PERCENTVIEW 274
# define PERCENTSTORAGECLASS 275
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 12,
	267, 104,
	58, 17,
	44, 104,
	-2, 145,
-1, 28,
	91, 150,
	-2, 100,
-1, 186,
	125, 61,
	-2, 64,
-1, 189,
	125, 58,
	-2, 64,
	};
# define YYNPROD 183
# define YYLAST 366
short yyact[]={

  49, 191, 190,  12,  12,  20,  20, 158, 214,  29,
 180,  20, 111, 156, 219,  30, 156,  35,  37, 162,
  18, 151, 162, 147,  45,  42, 121,  50,  52,  87,
  20, 257,  43,  18,  51,  61, 261,  64, 221, 257,
 121,  59,  20, 222, 129,  33, 232, 245, 233, 178,
 259, 196, 233,  51,  74,  76, 121, 186,  82, 121,
 260, 121,  77,  84, 253,  19,  85,  90, 254,  42,
  42,  42, 235,  98,  53, 154, 235, 236, 237, 258,
 212, 236, 237, 140,  99, 119, 136, 175, 114, 288,
 149,  48, 226,  46, 282,  56,  65, 173,  62, 215,
 124,  94, 147,  76,  24, 147, 165, 130,  98, 100,
  26,  63,  73,  60, 179, 141,  90, 115, 172, 147,
  75, 285, 276,  81,  98,  25,  97, 147,  57, 113,
  80,  41, 104,  24, 146,  69,  39, 152, 185, 268,
  76, 145, 160, 194, 266,  29, 203, 166,  78, 169,
  95, 132, 139, 101,  25,  18,  70,  18, 193, 209,
 176,  38,  89, 182,  81, 152, 123,  68, 284, 283,
 273, 264, 242, 202, 195, 187, 142, 198, 160, 138,
 122, 201, 117,  67, 252, 251, 250,  27, 161, 116,
 107, 102, 208,  72, 192,   4,  78,  13,  13,  22,
  91, 229,  93, 213, 174, 128,  92,  55, 103,  71,
 105, 181, 228,  54, 223,  58, 281, 227, 275, 269,
  18,  18, 280, 127, 161, 274,  18,  15, 189, 164,
 270,  14,  28,  78,  21,  21,  18,  16,  17,  18,
  21, 163, 263,  18, 163,  18, 246,  18,  47,  18,
 137, 159, 199, 218, 159, 183, 241,  18, 131,  21,
 153,  44, 265, 220, 217, 110, 163, 108,  18, 271,
 272,  21, 267, 225, 224, 177, 197, 120, 134, 279,
 240, 208, 256, 277, 278,  18,  47, 248, 287, 208,
 256, 120, 286, 200, 211, 239, 200, 234,  18, 231,
 163, 234, 238, 231, 163,  18, 206, 120, 205,  18,
 120,  18, 120, 210, 167, 207, 262, 243, 170, 204,
 168, 135,  66,   3,   2,   1,  36,  11,  10, 157,
 155, 106,  34,  79,   9, 171, 150, 244,  96,   7,
 247, 126, 125,  40,   6, 109,  83,  32,  31,   8,
 143, 249, 216, 188, 255, 118, 230, 184, 144, 133,
 112, 148,  88,  86,  23,   5 };
short yypact[]={

-1000,-1000, -37, -37,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,  64, -35,-224,-212,-224,-224,-1000,-1000,
-1000,-1000,-1000, 103, -10, -12,  -8,  41,-1000, -12,
-1000,-1000,-216,-1000,  54,-1000,  52,-1000,-1000, 142,
 123,-1000,  95,-1000,-1000,-1000,-1000,-1000,-1000,  93,
 153,-1000, -13,-224,  28,  32,-1000,  -8,-1000,-1000,
-1000,-1000,-224,-1000,-1000,-224,-237,-1000, -10, -10,
 -10,-1000,  48,-1000, -16,  94, 151,-1000,-1000,  73,
-1000,-1000, 150,   2,-1000,-1000,   6,-224,  -7,-1000,
 149,-1000, 141,-1000,  51, 139, 122,-1000,-1000,-224,
-1000,-1000,  28,-1000,-1000,-1000, -14,  48,-1000,-1000,
-1000,-1000,  92,-1000,-1000,-224,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,  48,-1000, 138, 108,-1000,  49,-1000,
-1000, 135,-1000,-100,-1000,-1000,-102,-1000,-1000,  28,
-1000, -18,-1000, -19,-1000,-1000,-224,-1000,-224,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000, 102,-1000,-1000,
-257,-257,-224,-1000,-102,-1000,  77,-1000, 134,-1000,
 -12,  99,-1000,  11,-1000,-1000,-224, -21,-257,-1000,
-224,-257, 132,-1000,  87,-1000,-1000,-1000,-1000,-1000,
 -12,-1000, 101,-1000,-1000,-1000,-1000,  46,-1000,-1000,
-1000,-1000,-224,-1000,-1000, -26,   4, -33,-1000,  -4,
-1000,  -8,-1000,-1000,  42,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000, 131, 102,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
 146, 145, 144,-1000,  30,  29,  38,  16,  21,-1000,
   0,-1000, 130,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-224,  85,-1000,-1000,  80,-1000,  42,-224,-224,
 129,-1000,-1000,  -1,-1000,-1000, -12,  42,  42, -31,
 128, 127,-1000,  -2,  -4, -12,-1000, -36,-1000 };
short yypgo[]={

   0,  46,   0,  93, 365, 364, 363, 362, 162, 361,
 360, 359, 358, 357,   8, 356, 101, 355,  47, 354,
  90, 353,   7,  57, 352, 351, 350, 349, 348, 347,
 346, 345, 344, 194,  65, 131, 136, 343, 120, 342,
 341, 339, 150, 338, 126,  86, 336, 335, 118,  97,
   2,   1, 334, 333, 130, 332, 331, 115, 330, 329,
  49, 114,  87, 328, 327, 326, 325, 324, 323, 195,
 322, 321, 320, 319, 318, 315, 314, 308, 306, 302,
 295, 280, 256, 242, 230, 225, 222, 219, 218, 216,
 215, 213, 209, 208, 207, 204, 201 };
short yyr1[]={

   0,   1,   2,   3,  67,  66,  68,  68,  69,  69,
  69,  69,  69,  69,  69,  70,   4,   5,   5,   5,
   6,   6,   6,   7,   7,  71,  72,   8,   9,   9,
  10,  10,  11,  11,  12,  13,  73,  13,  14,  14,
  15,  15,  15,  15,  15,  15,  15,  16,  16,  17,
  17,  18,  18,  19,  19,  74,  75,  20,  21,  21,
  76,  77,  22,  23,  78,  23,  24,  24,  24,  24,
  79,  24,  80,  24,  24,  81,  24,  82,  83,  84,
  24,  85,  86,  25,  87,  88,  89,  25,  26,  26,
  90,  27,  28,  28,  29,  29,  30,  30,  31,  31,
  91,  32,  33,  33,  34,  34,  34,  34,  34,  35,
  35,  35,  35,  35,  92,  35,  35,  36,  36,  37,
  37,  38,  38,  93,  38,  38,  39,  39,  40,  40,
  41,  41,  42,  42,  43,  43,  44,  44,  45,  45,
  46,  47,  47,  48,  48,  49,  49,  50,  50,  51,
  94,  52,  53,  53,  54,  56,  56,  57,  57,  95,
  96,  58,  58,  58,  58,  59,  59,  59,  59,  59,
  60,  60,  61,  62,  62,  63,  55,  55,  55,  64,
  65,  65,  65 };
short yyr2[]={

   0,   1,   1,   1,   0,   2,   1,   2,   1,   1,
   1,   1,   1,   1,   1,   0,   7,   0,   3,   4,
   0,   2,   1,   1,   3,   0,   0,   6,   0,   2,
   0,   4,   0,   2,   4,   0,   0,   3,   0,   2,
   1,   1,   1,   1,   3,   3,   3,   0,   2,   1,
   1,   0,   2,   1,   1,   0,   0,   5,   1,   1,
   0,   0,   5,   0,   0,   3,   1,   1,   1,   1,
   0,   4,   0,   4,   1,   0,   3,   0,   0,   0,
  10,   0,   0,  12,   0,   0,   0,  10,   0,   1,
   0,   5,   0,   1,   1,   2,   0,   2,   1,   1,
   0,   5,   1,   3,   1,   4,   3,   1,   1,   1,
   4,   1,   1,   3,   0,   4,   1,   0,   1,   1,
   3,   1,   4,   0,   4,   1,   0,   1,   1,   3,
   8,   9,   0,   1,   1,   3,   1,   2,   0,   2,
   3,   1,   3,   2,   7,   0,   2,   1,   2,   3,
   0,   5,   1,   2,   5,   0,   2,   0,   2,   0,
   0,   6,   2,   1,   3,   1,   1,   2,   2,   4,
   1,   2,   2,   0,   2,   3,   1,   2,   3,   3,
   1,   2,   3 };
short yychk[]={

-1000, -66, -67, -68, -69,  -4, -32, -41, -27, -52,
 -63, -64,  -2, -33, 268, 264, 274, 275, 257, -34,
  42, 271, -69,  -5,  40,  61, -49, 123, 267,  44,
  -2, -28, -29, 257, -55,  -2, -65,  -2,  58, -36,
 -37, -35,  -2,  42, 271,  34,  -3, 258, -34,  -2,
  -2,  42,  -2,  33, -91, -94, -34, -49, -90, 257,
  59,  -2,  44,  59,  -2,  44, -70,  41,  44,  40,
  61, -92,  40, 125,  -2, -38,  -2,  34,  -3, -53,
 -54,  91,  -2, -30,  -2,  -2,  -6, 266,  -7,  -8,
  -2, -35, -36, -35, -16, -42, -43, -44,  -2,  36,
 125,  59,  40, -93,  59, -54, -56,  40, 265, -31,
 263,  10, -10, 123,  -2, 124,  40,  41, -17,  34,
 261,  10,  41,  44,  -2, -39, -40, -38, -16,  58,
  -2, -42,  59, -11,  -8, -71, -45, -44,  41,  44,
  34, -57,  41, -26, -12, -22,  -2, 123,  -9, -20,
 -46, 123,  -2, -38,  93, -58,  34, -59, -22, 272,
  -2,  -1,  40, 262, -45, 125,  -2, -76, -72,  -2,
 -74, -47, -48, -49, -95, -62,  58, -57, -60, -61,
 267, -60,  -2, -20, -13,  61, -23,  41, -21, -23,
 -50, -51, -33,  59,  44,  -2,  40, -16,  -2, 273,
 -61,  -2,  41,  59, -73, -77, -78, -75, -51,  58,
 -48, -49,  34,  -2, -14, 125, -24, 260,  -1,  10,
 259,  34,  39, -22, 270, 269, 125, -22,  -2, -96,
 -15, 261,  -1,  10, 259,  34,  39,  40, -79, -80,
 -81, -82,  41, -62, -16, -18, -14, -16, -18, -25,
  40,  40,  40,  34,  39, -19, 261,  10,  41,  34,
  39,  36, -34, -83,  41,  -2,  59, -14,  59, -87,
 -84,  -2,  -2,  41, -85, -88, 123, -14, -14, -50,
 -86, -89, 125,  41,  41, 123, -22, -50, 125 };
short yydef[]={

   4,  -2,   0,   5,   6,   8,   9,  10,  11,  12,
  13,  14,  -2,   0,   0,  92,   0,   0,   2, 102,
 107, 108,   7,   0, 117,   0,   0,   0,  -2,   0,
 145,  90,  93,  94,   0, 176,   0, 180,  15,   0,
 118, 119, 109, 111, 112, 114, 116,   3, 106, 104,
   0, 146,   0,   0,   0,   0, 103,   0,  96,  95,
 175, 177,   0, 179, 181,   0,  20, 105,   0, 117,
   0,  47, 132,  18,   0,   0, 121, 123, 125,   0,
 152, 155,   0,   0, 178, 182,  30,   0,  22,  23,
   0, 120,   0, 113,   0,   0, 133, 134, 136,   0,
  19, 101, 126,  47, 151, 153,   0, 132,  91,  97,
  98,  99,   0,  32,  21,   0,  25, 110,  48, 115,
  49,  50, 138,   0, 137,   0, 127, 128,   0, 157,
 156,   0,  16,  88,  24,  28,   0, 135, 122,   0,
 124,   0, 138,   0,  33,  89,   0,  60,  26, 130,
 139,  55, 145, 129, 154, 158, 159, 173, 163, 157,
 165, 166,   0,   1,   0,  31,  35,  63,   0,  29,
  63,   0, 141,   0,  47, 162,   0,   0, 167, 170,
   0, 168,   0, 131,   0,  36,  -2,  27,  56,  -2,
  59, 147,   0, 140, 145, 143, 145,   0, 174, 164,
 171, 172,   0,  34,  38,   0,   0,   0, 148,   0,
 142,   0, 160, 169,  37,  62,  65,  66,  67,  68,
  69,  70,  72,  74,  75,  77,  57, 149,   0, 173,
  39,  40,  41,  42,  43,  47,  51,  38,  47,  51,
   0,   0,   0, 161,   0,   0,   0,   0,   0,  76,
   0,  78,   0,  44,  45,  52,  53,  54,  46,  71,
  73,   0,   0,  38, 144,   0,  84,  79,   0,   0,
   0,  81,  85,   0,  38,  38,   0,  82,  86,   0,
   0,   0,  80,   0,   0,   0,  87,   0,  83 };
#
# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps> &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 1:
# line 174 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_INT = Int( yypvt[-0].yt_int ); pf_setfileline( yyval.yt_INT ); } break;
case 2:
# line 179 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_ID = Id( Str( yypvt[-0].yt_casestring )); pf_setfileline( yyval.yt_ID ); } break;
case 3:
# line 184 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_INT = Int( yypvt[-0].yt_int ); pf_setfileline( yyval.yt_INT ); } break;
case 4:
# line 195 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ /* initialize variables and scanner state */
		  pl_filelinestack = Nilfilelinestack();
		  pl_nooperatorsstack = Nilnooperatorsstack();
		  pl_phylum = 0;
		  pl_withvariable = 0;
									  do_NORMAL();
		} break;
case 8:
# line 212 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ Thephylumdeclarations = mergephylumdeclarations( yypvt[-0].yt_phylumdeclaration, Thephylumdeclarations ); } break;
case 9:
# line 214 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ Therwdeclarations = Consrwdeclarations( yypvt[-0].yt_rwdeclaration, Therwdeclarations ); } break;
case 10:
# line 216 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ Thefndeclarations = Consfndeclarations( yypvt[-0].yt_fndeclaration, Thefndeclarations ); } break;
case 11:
# line 218 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ } break;
case 12:
# line 220 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ Theunparsedeclarations = Consunparsedeclarations( yypvt[-0].yt_unparsedeclaration, Theunparsedeclarations ); } break;
case 15:
# line 227 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ pl_phylum = yypvt[-2].yt_ID; } break;
case 16:
# line 229 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_phylumdeclaration = PhylumDeclaration( yypvt[-6].yt_ID, yypvt[-5].yt_storageoption, yypvt[-2].yt_productionblock, yypvt[-1].yt_Ccode_option ); v_extendoccur( pl_phylum, ITUserPhylum( yyval.yt_phylumdeclaration ) ); } break;
case 17:
# line 234 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageoption = NoStorageOption(); } break;
case 18:
# line 236 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageoption = PositiveStorageOption( yypvt[-1].yt_ID ); v_extendoccur( yypvt[-1].yt_ID, ITStorageClass() ); } break;
case 19:
# line 238 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageoption = NegativeStorageOption( yypvt[-1].yt_ID ); v_extendoccur( yypvt[-1].yt_ID, ITStorageClass() ); } break;
case 20:
# line 243 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_productionblock = Emptyproductionblock(); } break;
case 21:
# line 245 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_productionblock = ListAlternatives( makeListAlternatives( pl_phylum, yypvt[-0].yt_ID ), yypvt[-0].yt_ID );
		  Theargsnumbers = insert_in_argsnumbers(0, Theargsnumbers);
		  Theargsnumbers = insert_in_argsnumbers(2, Theargsnumbers);
		} break;
case 22:
# line 250 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_productionblock = NonlistAlternatives( yypvt[-0].yt_alternatives ); } break;
case 23:
# line 255 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_alternatives = Consalternatives( yypvt[-0].yt_alternative, Nilalternatives() ); } break;
case 24:
# line 257 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_alternatives = Consalternatives( yypvt[-0].yt_alternative, yypvt[-2].yt_alternatives ); } break;
case 25:
# line 261 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ pg_no_of_arguments = 0; } break;
case 26:
# line 261 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ Theargsnumbers = insert_in_argsnumbers(pg_no_of_arguments, Theargsnumbers); } break;
case 27:
# line 262 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_alternative = Alternative( yypvt[-5].yt_ID, yypvt[-2].yt_arguments );
		  v_extendoccur( yypvt[-5].yt_ID, ITUserOperator( yyval.yt_alternative, pl_phylum ) ); } break;
case 28:
# line 268 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_arguments = Nilarguments(); } break;
case 29:
# line 270 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_arguments = Consarguments( yypvt[-0].yt_ID, yypvt[-1].yt_arguments ); pg_no_of_arguments++; } break;
case 30:
# line 275 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ccode_option = CcodeOption( Nilattributes(), NilCtexts() ); } break;
case 31:
# line 277 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ccode_option = CcodeOption( yypvt[-2].yt_attributes, yypvt[-1].yt_Ctexts ); } break;
case 32:
# line 282 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_attributes = Nilattributes(); } break;
case 33:
# line 284 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_attributes = Consattributes( yypvt[-0].yt_attribute, yypvt[-1].yt_attributes ); } break;
case 34:
# line 289 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_attribute = Attribute( yypvt[-3].yt_ID, yypvt[-2].yt_ID, yypvt[-1].yt_attribute_initialisation_option ); } break;
case 35:
# line 294 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_attribute_initialisation_option = Noattribute_initialisation(); } break;
case 36:
# line 296 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPR(); } break;
case 37:
# line 298 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL();
		  yyval.yt_attribute_initialisation_option = Yesattribute_initialisation( yypvt[-0].yt_Cexpression ); } break;
case 38:
# line 308 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression = NilCexpression(); pf_setfileline( yyval.yt_Cexpression ); } break;
case 39:
# line 310 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression = ConsCexpression( yypvt[-0].yt_Cexpression_elem, yypvt[-1].yt_Cexpression ); yyval.yt_Cexpression->file = yypvt[-1].yt_Cexpression->file; yyval.yt_Cexpression->line = yypvt[-1].yt_Cexpression->line; } break;
case 40:
# line 315 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionPart( yypvt[-0].yt_casestring ); } break;
case 41:
# line 317 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionDollarvar( yypvt[-0].yt_INT ); } break;
case 42:
# line 319 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionNl( 1 ); } break;
case 43:
# line 321 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionNl( yypvt[-0].yt_int ); } break;
case 44:
# line 323 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionDQ( yypvt[-1].yt_CexpressionDQ ); } break;
case 45:
# line 325 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionSQ( yypvt[-1].yt_CexpressionSQ ); } break;
case 46:
# line 327 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cexpression_elem = CExpressionPack( yypvt[-1].yt_Cexpression ); } break;
case 47:
# line 332 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionDQ = NilCexpressionDQ(); } break;
case 48:
# line 334 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionDQ = ConsCexpressionDQ( yypvt[-0].yt_CexpressionDQ_elem, yypvt[-1].yt_CexpressionDQ ); } break;
case 49:
# line 339 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionDQ_elem = CExpressionDQPart( yypvt[-0].yt_casestring ); } break;
case 50:
# line 341 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionDQ_elem = CExpressionDQNl( 1 ); } break;
case 51:
# line 346 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionSQ = NilCexpressionSQ(); } break;
case 52:
# line 348 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionSQ = ConsCexpressionSQ( yypvt[-0].yt_CexpressionSQ_elem, yypvt[-1].yt_CexpressionSQ ); } break;
case 53:
# line 353 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionSQ_elem = CExpressionSQPart( yypvt[-0].yt_casestring ); } break;
case 54:
# line 355 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_CexpressionSQ_elem = CExpressionSQNl( 1 ); } break;
case 55:
# line 365 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_MainC(); pf_pushfileline(); } break;
case 56:
# line 367 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 57:
# line 369 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext = yypvt[-2].yt_Ctext; pf_setstacktopfileline( yyval.yt_Ctext ); pf_popfileline(); } break;
case 58:
# line 374 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext = yypvt[-0].yt_Ctext; pf_setstacktopfileline( yyval.yt_Ctext ); } break;
case 59:
# line 376 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ Ctext_elem tmp = CTextWithexpression( WEVariable( pl_withvariable ), yypvt[-0].yt_withcases );
		  pf_setstacktopfileline( tmp );
		  yyval.yt_Ctext = ConsCtext( tmp, NilCtext() );
		  pf_setstacktopfileline( yyval.yt_Ctext ); 
		  if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; } break;
case 60:
# line 386 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_C(); pf_pushfileline(); pf_push_no_operators(); } break;
case 61:
# line 388 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 62:
# line 390 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext = yypvt[-2].yt_Ctext; pf_setstacktopfileline( yyval.yt_Ctext ); pf_popfileline(); pf_pop_no_operators(); } break;
case 63:
# line 395 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext = NilCtext(); pf_setfileline( yyval.yt_Ctext ); } break;
case 64:
# line 397 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ pf_pushfileline(); } break;
case 65:
# line 399 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext = ConsCtext( yypvt[-0].yt_Ctext_elem, yypvt[-2].yt_Ctext ); pf_setstacktopfileline( yypvt[-0].yt_Ctext_elem ); pf_popfileline(); yyval.yt_Ctext->file = yypvt[-2].yt_Ctext->file; yyval.yt_Ctext->line = yypvt[-2].yt_Ctext->line; } break;
case 66:
# line 404 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext_elem = CTextLine( yypvt[-0].yt_casestring ); } break;
case 67:
# line 406 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext_elem = CTextDollarVar( yypvt[-0].yt_INT ); } break;
case 68:
# line 408 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext_elem = CTextNl( 1 ); } break;
case 69:
# line 410 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext_elem = CTextNl( yypvt[-0].yt_int ); } break;
case 70:
# line 412 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPRDQ(); } break;
case 71:
# line 414 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_C();
		  yyval.yt_Ctext_elem = CTextCexpressionDQ( yypvt[-1].yt_CexpressionDQ ); } break;
case 72:
# line 417 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPRSQ(); } break;
case 73:
# line 419 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_C();
		  yyval.yt_Ctext_elem = CTextCexpressionSQ( yypvt[-1].yt_CexpressionSQ ); } break;
case 74:
# line 423 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_C();
		  yyval.yt_Ctext_elem = CTextCbody( yypvt[-0].yt_Ctext ); } break;
case 75:
# line 426 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 76:
# line 428 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_C();
		  yyval.yt_Ctext_elem = yypvt[-0].yt_Ctext_elem; } break;
case 77:
# line 431 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 78:
# line 433 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPR(); } break;
case 79:
# line 435 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 80:
# line 437 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_C();
		  yyval.yt_Ctext_elem = CTextWithexpression( WECexpression( yypvt[-5].yt_Cexpression ), yypvt[-1].yt_withcases );
		  if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; } break;
case 81:
# line 445 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPR(); } break;
case 82:
# line 447 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 83:
# line 449 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctext_elem = CTextForeachwithcases( yypvt[-7].yt_ID, yypvt[-5].yt_Cexpression, WEVariable( yypvt[-9].yt_ID ), yypvt[-1].yt_withcases );
		  if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; } break;
case 84:
# line 452 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ non_default_outmostpattern = 0; } break;
case 85:
# line 453 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPR(); } break;
case 86:
# line 455 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 87:
# line 457 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ if ( yypvt[-8].yt_outmostpattern && yypvt[-8].yt_outmostpattern->prod_sel == sel_OPOperatorWildcard) {
			yyval.yt_Ctext_elem = CTextForeachexpression( yypvt[-5].yt_ID, yypvt[-3].yt_Cexpression, yypvt[-8].yt_outmostpattern->u.OPOperatorWildcard.ID_1, yypvt[-0].yt_Ctext );
		  } else {
			yyval.yt_Ctext_elem = CTextForeachpattern( yypvt[-5].yt_ID, yypvt[-3].yt_Cexpression, Withcase( Consoutmostpatterns( yypvt[-8].yt_outmostpattern, Niloutmostpatterns() ), yypvt[-0].yt_Ctext ) );
		  }
		} break;
case 88:
# line 467 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctexts = NilCtexts(); } break;
case 89:
# line 469 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Ctexts = ConsCtexts( yypvt[-0].yt_Ctext, NilCtexts() ); } break;
case 90:
# line 473 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ pf_pushfileline(); } break;
case 91:
# line 474 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{{includedeclaration pl_includedeclaration  = IncludeDeclaration( yypvt[-1].yt_includes );
		  set_includefiles( yypvt[-3].yt_includefiles, pl_includedeclaration );
		  pf_setstacktopfileline( pl_includedeclaration );
		  pf_popfileline();
		}} break;
case 92:
# line 483 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{{ includefile pl_includefile = IncludeFile( mkcasestring(INC_CODE) );
		  yyval.yt_includefiles = Consincludefiles( pl_includefile, Nilincludefiles() );
		}} break;
case 93:
# line 487 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_includefiles = yypvt[-0].yt_includefiles; } break;
case 94:
# line 492 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{{ includefile pl_includefile = IncludeFile( yypvt[-0].yt_casestring );
		  if (pl_includefile->newinclude) {
			v_report(Warning( NoFileLine(), ProblemSC( "old include redirection keyword (please replace the `KIMW_' part by `KC_'):", yypvt[-0].yt_casestring )));
			pl_includefile = pl_includefile->newinclude;
		  }
		  if ((pl_includefile->inc_type == include_file) || (pl_includefile->inc_type == include_header)) {
		        yyval.yt_includefiles = Consincludefiles( pl_includefile, Nilincludefiles() );
		  } else {
			v_report(NonFatal( NoFileLine(), ProblemSC( "unknown include redirection keyword:", yypvt[-0].yt_casestring ))); 
		        yyval.yt_includefiles = Nilincludefiles();
		  }
		}} break;
case 95:
# line 505 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{{ includefile pl_includefile = IncludeFile( yypvt[-0].yt_casestring );
		  if (pl_includefile->newinclude) {
			v_report(Warning( NoFileLine(), ProblemSC( "old include redirection keyword (please replace the `KIMW_' part by `KC_'):", yypvt[-0].yt_casestring )));
			pl_includefile = pl_includefile->newinclude;
		  }
		  if ((pl_includefile->inc_type == include_file) || (pl_includefile->inc_type == include_header)) {
		        yyval.yt_includefiles = Consincludefiles( pl_includefile, yypvt[-1].yt_includefiles );
		  } else {
			v_report(NonFatal( NoFileLine(), ProblemSC( "unknown include redirection keyword:", yypvt[-0].yt_casestring ))); 
		        yyval.yt_includefiles = yypvt[-1].yt_includefiles;
		  }
		}} break;
case 96:
# line 521 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_includes = Nilincludes(); } break;
case 97:
# line 523 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_includes = Consincludes( yypvt[-0].yt_include, yypvt[-1].yt_includes ); } break;
case 98:
# line 528 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_include = Include( yypvt[-0].yt_casestring ); } break;
case 99:
# line 530 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_include = IncludeNl( 1 ); } break;
case 100:
# line 535 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; } break;
case 101:
# line 538 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_rwdeclaration = RwDeclaration( yypvt[-4].yt_outmostpatterns, yypvt[-1].yt_term ); } break;
case 102:
# line 543 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpatterns = Consoutmostpatterns( yypvt[-0].yt_outmostpattern, Niloutmostpatterns() ); } break;
case 103:
# line 545 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpatterns = Consoutmostpatterns( yypvt[-0].yt_outmostpattern, yypvt[-2].yt_outmostpatterns ); } break;
case 104:
# line 550 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpattern = OPOperatorWildcard( yypvt[-0].yt_ID ); non_default_outmostpattern = 1; } break;
case 105:
# line 552 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpattern = OPOperator( yypvt[-3].yt_ID, yypvt[-1].yt_patterns ); non_default_outmostpattern = 1; } break;
case 106:
# line 554 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpattern = OPNonLeafVariable( yypvt[-2].yt_ID, yypvt[-0].yt_outmostpattern ); non_default_outmostpattern = 1; } break;
case 107:
# line 556 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpattern = OPWildcard(); } break;
case 108:
# line 558 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_outmostpattern = OPWildcard(); } break;
case 109:
# line 563 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_pattern = PVariable( yypvt[-0].yt_ID ); } break;
case 110:
# line 565 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_pattern = POperator( yypvt[-3].yt_ID, yypvt[-1].yt_patterns ); } break;
case 111:
# line 567 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_pattern = PWildcard(); } break;
case 112:
# line 569 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_pattern = PWildcard(); } break;
case 113:
# line 571 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_pattern = PNonLeafVariable( yypvt[-2].yt_ID, yypvt[-0].yt_pattern ); } break;
case 114:
# line 573 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPRDQ(); } break;
case 115:
# line 575 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL();
		  yyval.yt_pattern = PStringLiteral( yypvt[-1].yt_CexpressionDQ ); } break;
case 116:
# line 578 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_pattern = PIntLiteral( yypvt[-0].yt_INT ); } break;
case 117:
# line 583 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_patterns = Nilpatterns(); } break;
case 118:
# line 585 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_patterns = yypvt[-0].yt_patterns; } break;
case 119:
# line 590 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_patterns = Conspatterns( yypvt[-0].yt_pattern, Nilpatterns() ); } break;
case 120:
# line 592 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_patterns = Conspatterns( yypvt[-0].yt_pattern, yypvt[-2].yt_patterns ); } break;
case 121:
# line 596 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_term = TVariable( yypvt[-0].yt_ID ); } break;
case 122:
# line 598 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_term = TOperator( yypvt[-3].yt_ID, yypvt[-1].yt_terms ); } break;
case 123:
# line 600 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPRDQ(); } break;
case 124:
# line 602 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL();
		  yyval.yt_term = TStringLiteral( yypvt[-1].yt_CexpressionDQ ); } break;
case 125:
# line 605 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_term = TIntLiteral( yypvt[-0].yt_INT ); } break;
case 126:
# line 610 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_terms = Nilterms(); } break;
case 127:
# line 612 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_terms = yypvt[-0].yt_terms; } break;
case 128:
# line 617 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_terms = Consterms( yypvt[-0].yt_term, Nilterms() ); } break;
case 129:
# line 619 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_terms = Consterms( yypvt[-0].yt_term, yypvt[-2].yt_terms ); } break;
case 130:
# line 624 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_fndeclaration = FnDeclaration( yypvt[-7].yt_ID, yypvt[-6].yt_int, yypvt[-5].yt_ID, yypvt[-3].yt_fnarguments, yypvt[-1].yt_Cvariabledeclarations, yypvt[-0].yt_Ctext, GlobalFn() );
		  pf_resetwithvariable();
		  v_defoccur( yypvt[-5].yt_ID, ITUserFunction( GlobalFn() ) ); } break;
case 131:
# line 628 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_fndeclaration = FnDeclaration( yypvt[-7].yt_ID, yypvt[-6].yt_int, yypvt[-5].yt_ID, yypvt[-3].yt_fnarguments, yypvt[-1].yt_Cvariabledeclarations, yypvt[-0].yt_Ctext, LocalFn( pg_filename ) );
		  pf_resetwithvariable();
		  v_defoccur( yypvt[-5].yt_ID, ITUserFunction( LocalFn( pg_filename ) ) ); } break;
case 132:
# line 635 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_fnarguments = Nilfnarguments(); } break;
case 133:
# line 637 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_fnarguments = yypvt[-0].yt_fnarguments; } break;
case 134:
# line 642 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_fnarguments = Consfnarguments( yypvt[-0].yt_ID, Nilfnarguments() ); } break;
case 135:
# line 644 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_fnarguments = Consfnarguments( yypvt[-0].yt_ID, yypvt[-2].yt_fnarguments ); } break;
case 136:
# line 649 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_ID = yypvt[-0].yt_ID; } break;
case 137:
# line 651 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_ID = yypvt[-0].yt_ID; pf_setwithvariable( yypvt[-0].yt_ID ); } break;
case 138:
# line 656 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariabledeclarations = NilCvariabledeclarations(); } break;
case 139:
# line 658 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariabledeclarations = ConsCvariabledeclarations( yypvt[-0].yt_Cvariabledeclaration, yypvt[-1].yt_Cvariabledeclarations ); } break;
case 140:
# line 663 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariabledeclaration = CVariabledeclaration( yypvt[-2].yt_ID, yypvt[-1].yt_Cvariables ); } break;
case 141:
# line 668 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariables = ConsCvariables( yypvt[-0].yt_Cvariable, NilCvariables() ); } break;
case 142:
# line 670 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariables = ConsCvariables( yypvt[-0].yt_Cvariable, yypvt[-2].yt_Cvariables ); } break;
case 143:
# line 675 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariable = CVPointer( yypvt[-1].yt_int, yypvt[-0].yt_ID ); } break;
case 144:
# line 677 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_Cvariable = CVFunction( yypvt[-6].yt_int, yypvt[-4].yt_int, yypvt[-3].yt_ID ); } break;
case 145:
# line 682 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_int = 0; } break;
case 146:
# line 684 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_int = yypvt[-1].yt_int + 1; } break;
case 147:
# line 689 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_withcases = Conswithcases( yypvt[-0].yt_withcase, Nilwithcases() ); } break;
case 148:
# line 691 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_withcases = Conswithcases( yypvt[-0].yt_withcase, yypvt[-1].yt_withcases ); } break;
case 149:
# line 696 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_withcase = Withcase( yypvt[-2].yt_outmostpatterns, yypvt[-0].yt_Ctext ); } break;
case 150:
# line 701 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; } break;
case 151:
# line 704 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparsedeclaration = UnparseDeclaration( yypvt[-4].yt_outmostpatterns, yypvt[-1].yt_unparseclauses ); } break;
case 152:
# line 709 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseclauses = Consunparseclauses( yypvt[-0].yt_unparseclause, Nilunparseclauses() ); } break;
case 153:
# line 711 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseclauses = Consunparseclauses( yypvt[-0].yt_unparseclause, yypvt[-1].yt_unparseclauses ); } break;
case 154:
# line 719 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ if (eq_viewnames( yypvt[-3].yt_viewnames, Nilviewnames())) {
		      yyval.yt_unparseclause = UnparseClause( Consviewnames( Id( Str( mkcasestring( "base_view" ))), yypvt[-3].yt_viewnames ), yypvt[-1].yt_unparseitems );
		  } else {
		      yyval.yt_unparseclause = UnparseClause( yypvt[-3].yt_viewnames, yypvt[-1].yt_unparseitems );
		} } break;
case 155:
# line 728 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnames = Nilviewnames(); } break;
case 156:
# line 730 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnames = Consviewnames( yypvt[-0].yt_ID, yypvt[-1].yt_viewnames ); } break;
case 157:
# line 735 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseitems = Nilunparseitems(); } break;
case 158:
# line 737 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseitems = Consunparseitems( yypvt[-0].yt_unparseitem, yypvt[-1].yt_unparseitems ); } break;
case 159:
# line 742 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_CEXPRDQ(); } break;
case 160:
# line 744 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ do_NORMAL(); } break;
case 161:
# line 746 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseitem = UnpStr( yypvt[-3].yt_CexpressionDQ, yypvt[-0].yt_viewnameoption ); } break;
case 162:
# line 748 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseitem = UnpSubexpr( yypvt[-1].yt_unpsubterm, yypvt[-0].yt_viewnameoption ); } break;
case 163:
# line 750 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseitem = UnpCtext( yypvt[-0].yt_Ctext ); } break;
case 164:
# line 752 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unparseitem = UnpBody( yypvt[-1].yt_unparseitems ); } break;
case 165:
# line 757 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpsubterm = UnpSubTerm( yypvt[-0].yt_ID ); } break;
case 166:
# line 759 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpsubterm = UnpDollarvarTerm( yypvt[-0].yt_INT ); } break;
case 167:
# line 761 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpsubterm = UnpSubAttr( yypvt[-1].yt_ID, yypvt[-0].yt_unpattributes ); } break;
case 168:
# line 763 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpsubterm = UnpDollarvarAttr( yypvt[-1].yt_INT, yypvt[-0].yt_unpattributes ); } break;
case 169:
# line 765 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpsubterm = UnpCastedVariable( yypvt[-2].yt_ID, yypvt[-0].yt_ID ); } break;
case 170:
# line 770 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpattributes = Consunpattributes( yypvt[-0].yt_ID, Nilunpattributes() ); } break;
case 171:
# line 772 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_unpattributes = Consunpattributes( yypvt[-0].yt_ID, yypvt[-1].yt_unpattributes ); } break;
case 172:
# line 777 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_ID = yypvt[-0].yt_ID; } break;
case 173:
# line 782 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnameoption = NoViewname(); } break;
case 174:
# line 784 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnameoption = YesViewname( yypvt[-0].yt_ID ); } break;
case 175:
# line 789 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnames = yypvt[-1].yt_viewnames; pg_viewshavebeendefined = True; } break;
case 176:
# line 794 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnames = Consviewnames( yypvt[-0].yt_ID, Nilviewnames());
		  v_add_to_viewnames( yypvt[-0].yt_ID );
		  v_extendoccur( yypvt[-0].yt_ID, ITUserView() ); } break;
case 177:
# line 798 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnames = Consviewnames( yypvt[-0].yt_ID, yypvt[-1].yt_viewnames );
		  v_add_to_viewnames( yypvt[-0].yt_ID );
		  v_extendoccur( yypvt[-0].yt_ID, ITUserView() ); } break;
case 178:
# line 802 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_viewnames = Consviewnames( yypvt[-0].yt_ID, yypvt[-2].yt_viewnames );
		  v_add_to_viewnames( yypvt[-0].yt_ID );
		  v_extendoccur( yypvt[-0].yt_ID, ITUserView() ); } break;
case 179:
# line 809 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageclasses = yypvt[-1].yt_storageclasses; pg_storageclasseshavebeendefined = True; } break;
case 180:
# line 814 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageclasses = Consstorageclasses( yypvt[-0].yt_ID, Nilstorageclasses());
		  v_add_to_storageclasses( yypvt[-0].yt_ID, f_emptyId() );
		  v_extendoccur( yypvt[-0].yt_ID, ITStorageClass() ); } break;
case 181:
# line 818 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageclasses = Consstorageclasses( yypvt[-0].yt_ID, yypvt[-1].yt_storageclasses );
		  v_add_to_storageclasses( yypvt[-0].yt_ID, f_emptyId() );
		  v_extendoccur( yypvt[-0].yt_ID, ITStorageClass() ); } break;
case 182:
# line 822 "/home/tools/belinfan/src/Kimwitu.V3_7/kimwy.y"
{ yyval.yt_storageclasses = Consstorageclasses( yypvt[-0].yt_ID, yypvt[-2].yt_storageclasses );
		  v_add_to_storageclasses( yypvt[-0].yt_ID, f_emptyId() );
		  v_extendoccur( yypvt[-0].yt_ID, ITStorageClass() ); } break;
		}
		goto yystack;  /* stack new state and value */

	}
